#include <cstdio>
#include <cstring>
using namespace std;
int main(int argc, char *argv[]) {
	if (argc != 2) {
		printf("Usage: isapt filename\n");
		return -1;
		}
	FILE *in = fopen(argv[1],"rb");
	if (in == 0) {
		printf("Can't open %s\n", argv[1]);
		return -1;
		}
	char cbuf[12];
	int numbits;
	int numcomponents;
	int major_version;
	int minor_version;
	int encoder_subversion;
	int quality;
	fread(cbuf,1,11,in);
	fclose(in);
	major_version = cbuf[3] - '0';
	minor_version = cbuf[5] - '0';
	encoder_subversion = cbuf[6] - '0';
	numcomponents = cbuf[7] - '0';
	numbits = cbuf[8] - '0';
	quality = cbuf[9];
	cbuf[3] = 0;
	if (strcmp(cbuf,"apt")) {
		printf("%s is not an APT-encoded file\n", argv[1]);
		return -1;
		}
	printf("%s: APT v%d.%d (encoder subversion %d). ",argv[1],
		major_version, minor_version, encoder_subversion);
	if (numcomponents != 1)
		printf("%d components of %d bits. APT quality %d.\n",
			numcomponents, numbits, quality);
	else
		printf("%d component of %d bits. APT quality %d.\n",
			numcomponents, numbits, quality);
	return 0;
	}
